import { OnInit, EventEmitter, TemplateRef } from '@angular/core';
import { Fcomponent } from './f';
export declare abstract class Fcgrand extends Fcomponent implements OnInit {
    editDialogRef: TemplateRef<{}>;
    editFooterDialogRef: TemplateRef<{}>;
    viewDialogRef: TemplateRef<{}>;
    viewFooterDialogRef: TemplateRef<{}>;
    workflowDialogRef: TemplateRef<{}>;
    workflowFooterDialogRef: TemplateRef<{}>;
    EVENT: any;
    props: any;
    parentProps: any;
    /**
     * 事件
     */
    fcEvent: EventEmitter<any>;
    /**
     * 当模型及产品id存在时，则初始化相关的内容，包含模型描述，模型对应的属性及事件
     * @param pid 产品id
     * @param aid 模型id
     */
    constructor(stateName: string, EVENT: any, mid?: string, aid?: string);
    /**
     * 初始化当前对象内容
     */
    ngOnInit(): void;
    /**
     * 初始化子类的数据对象
     * @param data 初始化数据对象
     */
    abstract initChildData(): any;
    /**
     * 初始化孙子类的数据对象
     * @param data 初始化数据对象
     */
    abstract initData(): any;
    /**
     * 工作流程设置
     * @param mainObj 操作对象内容
     */
    initWorkflow(mainObj: any): void;
    /**
     * 工作流程启动之前
     * @param action 事件
     */
    beforeWorkflow(param: any): boolean;
    /**
     * 工作流程
     * @param action 事件
     */
    workflow(mainObj: any): void;
    /**
     * 工作流程
     * @param action 事件
     */
    afterWorkflow(param: any): void;
    /**
     * 获取确认弹窗，需要传点ok后的回调函数及点取消后的回调函数
     * @param content 提示内容
     * @param title 标题
     * @param ok 确认方法
     * @param cancel 取消的方法
     */
    confirm(content: string, title: string, ok: () => {}, cancel: () => {}): void;
    /**
     * 自定义事件名称，所有自定义事件的入口
     * @param eventName 事件名称
     * @param param 参数
     * overload
     */
    event(eventName: string, param?: any): void;
    /**
     * 打开弹窗
     * @param uuid 弹窗的uuid
     * @param title 弹窗标题
     * @param dialogRef 弹窗引用
     * @param footerRef 自定义弹窗工具栏
     * @param width 弹窗宽度
     */
    openDialog(uuid: string, title: string, dialogRef: TemplateRef<{}>, footerRef: TemplateRef<{}>, width: string, canClose?: boolean): void;
    /**
     * 加载数据
     * @param data 加载完数据后
     */
    finishLoading(data: any): void;
    /**
     * 打开编辑弹窗
     * @param width 弹窗宽度
     */
    openEditDialog(width?: string, canClose?: boolean): void;
    /**
     * 预览前加载数据
     */
    beforeView(mainObj: any): boolean;
    /**
     * 打开浏览弹窗
     * @param width 弹窗宽度
     */
    openViewDialog(width?: string, canClose?: boolean): void;
    /**
     * 打开浏览弹窗
     * @param width 弹窗宽度
     */
    openWorkflowDialog(width?: string, canClose?: boolean): void;
    /**
     * 关闭弹窗
     * @param modelUuid 弹窗的uuid
     */
    closeDialog(modelUuid: string): void;
    /**
     * 关闭编辑弹窗
     */
    closeEditDialog(): void;
    /**
     * 关闭浏览弹窗
     */
    closeViewDialog(): void;
    /**
     * 关闭工作流弹窗
     */
    closeWorkflowDialog(): void;
}
